;WriteStr v1.00

	include		"doorsos.h"
	include		"mac2.h"
	xdef		_main
	xdef		_comment
	xdef		_ti92plus			;on for 92p
	;xdef		_ti89				;on for 89

_main:
					;Load address range for parameters
	move.l		($76fc),a4	;address last bit
	;lea		($7702),a3	;address first bit
					;Tests parameters, then store
	bsr		expr
	move.l		d1,d4
	cmp.w		#239,d4				;on for 92p
	;cmp.w		#159,d4				;on for 89
	bgt		er5
	bsr		expr
	move.l		d1,d5
	cmp.w		#102,d5				;on for 92p
	;cmp.w		#76,d5				;on for 89
	bgt		er5
	bsr		expr
	move.l		d1,d6
	cmp.w		#4,d6
	bgt		er5
	bsr		expr
	move.l		d1,d7
	cmp.w		#2,d7
	bgt		er5
str:					;Test string
	cmp.b		#$E5,(a4)
	beq		er4
	cmp.b		#$2D,(a4)
	bne		er3
	move.b		-(a4),d0
againstr:
	tst.b		-(a4)
	beq		okstr
	bra		againstr
okstr:
	move.b		-(a4),d0
	cmp.b		#$E5,d0
	bne		er1
	lea		2(a4),a3
					;move below toolbar
	add.b		#$12,d5				;on for 92p
	;add.b		#$10,d5				;on for 89
					;transfer graph screen to LCD MEM
	move.w		#$0010,d0			;on for 92p
	;move.w		#$0012,d0			;on for 89
	handle_ptr	d0,a5
	add.l		#4,a5
					;offset for toolbar on top of screen
	lea		doorsos::main_lcd+$21C,a6	;on for 92p
	;lea		doorsos::main_lcd+$1e0,a6	;on for 89
	move.l		#102,d1				;on for 92p
	;move.l		#76,d1				;on for 89
gr2fr2:
	move.l		#29,d0				;on for 92p
	;move.l		#19,d0				;on for 89
gr2fr:
	move.b		(a5)+,(a6)+
	dbra		d0,gr2fr
	;lea		$A(a6),a6			;on for 89
	dbra		d1,gr2fr2
					;displays the string
	SetFont		d7
	WriteStrA 	d4,d5,d6,a3
					;transfer LCD MEM to graph screen
	move.w		#$0010,d0			;on for 92p
	;move.w		#$0012,d0			;on for 89
	handle_ptr 	d0,a5
	add.l		#4,a5
	lea.l		doorsos::main_lcd+$21C,a6	;on for 92p
	;lea.l		doorsos::main_lcd+$1e0,a6	;on for 89
	move.l		#102,d1				;on for 92p
	;move.l		#76,d1				;on for 89
fr2gr2:
	move.l		#29,d0				;on for 92p
	;move.l		#19,d0				;on for 89
fr2gr:
	move.b		(a6)+,(a5)+
	dbra		d0,fr2gr
	;lea		$A(a6),a6			;on for 89
	dbra		d1,fr2gr2
	bra		exit
					;setup error message
er1:	move.w		#940,-(a7)	;too many args
	bra		error
er2:	move.w		#210,-(a7)	;data type
	bra		error
er3:	move.w		#130,-(a7)	;must be string
	bra		error
er4:	move.w		#930,-(a7)	;too few args
	bra		error
er5:	move.w		#260,-(a7)	;domain


error:					;Usage and Error message
	pea		_comment
	jsr		doorsos::ST_showHelp
	lea		4(a7),a7
	jsr		doorsos::ERD_dialog
	lea		2(a7),a7
	lea		ret_val,a3
	move.l  	a3,doorsos::ReturnValue
exit:
	SetFont		#1
	rts
;-----------------------------------------sub routines
expr:					;Test expression
	clr.l		d1
	cmp.b		#$E5,(a4)
	beq		not_enough
	cmp.b		#$1F,(a4)
	bne		not_good
	move.b		-(a4),d0
	tst.b		d0
	beq		zeroF
	cmp.b		#1,d0
	bne		not_enough
	move.b		-(a4),d1
zeroF:
	move.b		-(a4),d0
	rts

not_enough:
	lea		4(a7),a7
	bra		er4
	
not_good:
	lea		4(a7),a7
	bra		er2

;-----------------------------------------------------
		dc.b	0
_comment	dc.b	"WriteStr(X,Y,COL,FONT,STR)",0
ret_val		dc.b	$2D
;-----------------------------------------------------
	end